%define mpiimpl openmpi
%define mpidir %_libexecdir/%mpiimpl

Name: freepooma
Version: 2.4.1
Release: alt0.cvs20090410.M50.1
Summary: Element-wise, data-parallel, and stencil-based physics computations
License: MIT
Group: Sciences/Mathematics
Url: http://www.netlib.org/linpack/
Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>

# cvs -d:pserver:anonymous@cvs.sv.gnu.org:/sources/freepooma co .
Source: %name-%version.tar.gz

Requires: lib%name-devel = %version-%release

BuildPreReq: gcc-fortran gcc-c++ libcheetah-devel pdtoolkit libpdtoolkit-devel
BuildPreReq: libgmp-devel-static libgmp_cxx-devel-static %mpiimpl-devel-static
BuildPreReq: libhdf5-devel libfftw-devel makedepend libpete-devel
BuildPreReq: doxygen graphviz

%description
FreePOOMA is a C++ library supporting element-wise, data-parallel, and
stencil-based physics computations using one or more processors.  The
library automatically handles all interprocessor communication,
obviating the need for any explicit communication code.  The library
supports high-level syntax close to mathematical or algorithmic syntax
(like Fortran 95), easing the conversion from algorithms to code.

FreePOOMA is based on POOMA, originally developed at Los Alamos
National Laboratory.

%package -n lib%name-devel
Summary: Static development files of FreePOOMA
Group: Development/Other
Requires: %name = %version-%release

%description -n lib%name-devel
FreePOOMA is a C++ library supporting element-wise, data-parallel, and
stencil-based physics computations using one or more processors.  The
library automatically handles all interprocessor communication,
obviating the need for any explicit communication code.  The library
supports high-level syntax close to mathematical or algorithmic syntax
(like Fortran 95), easing the conversion from algorithms to code.

This package contains static development files of FreePOOMA.

%package -n lib%name-devel-doc
Summary: Documentation for FreePOOMA
Group: Development/Documentation
BuildArch: noarch
Requires: lib%name-devel = %version-%release

%description -n lib%name-devel-doc
FreePOOMA is a C++ library supporting element-wise, data-parallel, and
stencil-based physics computations using one or more processors.  The
library automatically handles all interprocessor communication,
obviating the need for any explicit communication code.  The library
supports high-level syntax close to mathematical or algorithmic syntax
(like Fortran 95), easing the conversion from algorithms to code.

This package contains development documentation for FreePOOMA.

%prep
%setup

%build
export CHEETAHDIR=%prefix
export PDTDIR=%prefix
export PETEDIR=%prefix
export POOMASUITE=LINUXgcc
export PATH=$PATH:%mpidir/bin
sed -i 's|(MPIDIR)|%mpidir|g' config/arch/LINUXgcc.conf
./configure \
	--prefix %prefix \
	--arch LINUXgcc \
	--with-fortran \
	--openmp \
	--mpi \
	--hdf5 \
	--fftw \
	--opt \
	--ex \
	--pool
%make_build
%make_build examples
pushd docs/reference
%make html
rm -f *.doxygen Makefile
popd

%install
install -d %buildroot%_bindir
install -d %buildroot%_libdir
install -d %buildroot%_includedir/%name
install -d %buildroot%_docdir/%name

install -m644 lib/LINUXgcc/*.a %buildroot%_libdir
install -m644 lib/LINUXgcc/*.h %buildroot%_includedir/%name

pushd examples
for dir in $(find * -type d ! -name LINUXgcc); do
	rm -f $dir/LINUXgcc/*.* $dir/LINUXgcc/Makefile
	if [ -d $dir/LINUXgcc ] && [ $(ls $dir/LINUXgcc|wc -l) -ne 0 ]; then
		install -m755 $dir/LINUXgcc/* %buildroot%_bindir
	fi
	rm -fR $dir/LINUXgcc
	if [ $(ls -l $dir|egrep '^\-'|wc -l) -ne 0 ]; then
		install -d %buildroot%_docdir/%name/examples/$dir
		for i in $(ls $dir); do
			if [ -f $i ]; then
				install -p -m644 $i %buildroot%_docdir/%name/examples/$dir
			fi
		done
	fi
done
popd

pushd src
rm -fR $(find ./ -type d -name tests)
for dir in $(find ./ -type d ! -name LINUXgcc); do
	if [ $(ls $dir/*.h|wc -l) -ne 0 ]; then
		install -d %buildroot%_includedir/%name/$dir
		install -p -m644 $dir/*.h %buildroot%_includedir/%name/$dir
	fi
done
popd

install -p -m644 docs/*.* %buildroot%_docdir/%name
mv docs/reference/html docs/reference/reference
mv docs/reference/reference %buildroot%_docdir/%name/

%files
%doc CREDITS LICENSE* README*
%_bindir/*

%files -n lib%name-devel
%_libdir/*
%_includedir/*

%files -n lib%name-devel-doc
%_docdir/%name

%changelog
* Mon May 18 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 2.4.1-alt0.cvs20090410.M50.1
- Port for Branch 5.0

* Sun May 17 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 2.4.1-alt1.cvs20090410
- Initial build for Sisyphus

